<template>
  <div class="input-group">
    <input
      v-model.trim="$v.minValue.$model"
      v-debounce:1s="updateMin"
      v-bind="addProperties(parameter, HTMLInputElement)"
      :debounce-events="['change', 'keyup']"
      placeholder="min value"
      class="form-control"
      :class="{ 'is-invalid': errorMin }"
      type="number"
      :step="getSteps"
      :min="param.options.min"
      :max="param.value.max"
      :disabled="disabled"
    />
    <input
      v-model.trim="$v.maxValue.$model"
      v-debounce:1s="updateMax"
      v-bind="addProperties(parameter, HTMLInputElement)"
      :debounce-events="['change', 'keyup']"
      placeholder="max value"
      class="form-control ml-2"
      :class="{ 'is-invalid': errorMax }"
      type="number"
      :step="getSteps"
      :min="param.value.min"
      :max="param.options.max"
      :disabled="disabled"
    />
  </div>
</template>

<script>
import { required, minValue, maxValue } from 'vuelidate/lib/validators';
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      minValue: 0,
      maxValue: 0,
      errorMin: false,
      errorMax: false,
      HTMLInputElement: null,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    getSteps() {
      return this.param.options && this.param.options.step
        ? this.param.options.step
        : 1;
    },
  },
  watch: {
    param(newData) {
      this.minValue = newData.value.min || 0;
      this.maxValue = newData.value.max || 0;
      this.errorMin = this.minValueIncorrect(this.minValue);
      this.errorMax = this.maxValueIncorrect(this.maxValue);
      if (this.errorMin || this.errorMax) {
        this.changeStateScenario(this.parameter.key, true);
      } else {
        this.changeStateScenario(this.parameter.key, false);
      }
    },
  },
  mounted() {
    this.HTMLInputElement = HTMLInputElement;
  },
  beforeMount() {
    this.minValue = this.param.value.min || 0;
    this.maxValue = this.param.value.max || 0;
  },
  validations() {
    if (this.param.required) {
      const validators = {
        minValue: {
          required,
        },
        maxValue: {
          required,
        },
      };
      if (this.param.options) {
        if (this.param.options.min) {
          validators.minValue.minValue = minValue(this.param.options.min);
        }
        if (this.param.options.max) {
          validators.maxValue.maxValue = maxValue(this.param.options.max);
        }
      }
      return validators;
    } else {
      return {
        minValue: {},
        maxValue: {},
      };
    }
  },
  methods: {
    async updateMin(value) {
      if (this.disabled) return;
      value = !Number.isInteger(this.param.options?.step)
        ? parseFloat(value)
        : parseInt(value);
      if (!this.$v.minValue.error && !this.minValueIncorrect(value)) {
        this.errorMin = false;
        if (!this.errorMax) {
          this.changeStateScenario(this.parameter.key, false);
          await this.updateParameter({
            min: value,
            max: this.param.value.max,
          });
        }
      } else {
        this.errorMin = true;
        this.changeStateScenario(this.parameter.key, true);
      }
    },
    async updateMax(value) {
      if (this.disabled) return;
      value = !Number.isInteger(this.param.options?.step)
        ? parseFloat(value)
        : parseInt(value);
      if (value && !this.$v.maxValue.error && !this.maxValueIncorrect(value)) {
        this.errorMax = false;
        if (!this.errorMin) {
          this.changeStateScenario(this.parameter.key, false);
          await this.updateParameter({
            min: this.param.value.min,
            max: value,
          });
        }
      } else {
        this.errorMax = true;
        this.changeStateScenario(this.parameter.key, true);
      }
    },
    minValueIncorrect(value) {
      return (
        (this.param.options &&
          this.param.options.min &&
          value < this.param.options.min) ||
        value > this.param.value.max ||
        value > this.param.options.max
      );
    },
    maxValueIncorrect(value) {
      return (
        (this.param.options &&
          this.param.options.max &&
          value > this.param.options.max) ||
        value < this.param.value.min ||
        value < this.param.options.min
      );
    },
    async updateParameter(newValue) {
      await this.updateValue(this.parameter.key, newValue);
    },
  },
};
</script>
